<?php

namespace Wechat\Work;

use GuzzleHttp\Client;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\Psr7\Uri;

class Base
{

    protected $client;

    public function __construct()
    {
        $this->client = new Client([
            'base_uri' => 'https://qyapi.weixin.qq.com/cgi-bin/',
            'timeout' => '3',
//            'proxy' => '3',
        ]);
    }

    protected function transformForJsonRequest($method, $uri, array $params = null)
    {
        $uri = new Uri($uri);
        $uri = Uri::withQueryValue($uri, 'access_token', $this->getAccessToken());
        $request = new Request($method, $uri, [], \GuzzleHttp\json_encode($params));
        return $request;
    }

    protected function getAccessToken()
    {
        $corpId = 'ww9ed271946b8fc4a4';
        $agentId = '1000015';
        $agentSecret = 'zH3N1fwrECl913R1r17MjDiNhMKSlJf2P3tSXmk_YG0';

        $cache = app('cache');

        $key = 'wechat_work_access_token_' . $agentId;

        $token = $cache->get($key);
        if ($token) {
            return $token;
        }

        $url = "https://qyapi.weixin.qq.com/cgi-bin/gettoken?corpid=$corpId&corpsecret=$agentSecret";

        $client = new Client();
        $resp = $client->get($url);

        $body = json_decode($resp->getBody(), true);

        if ($body['errcode'] == 0) {
            $cache->put($key, $body['access_token'], $body['expires_in'] / 60);
            return $body['access_token'];
        } else {
            return null;
        }
    }


}